Subject: bug#44574: guix weather not checking all substitute urls

From: Efraim Flashner <[email-masked]>
Date: Wed, 11 Nov 2020 13:30:05 +0200

I would have assumed that it would check for all of the substitute urls
I listed and not just the first one. Most of the packages listed below
I've test built on my pine64 so they shouldn't appear in the list
anymore.

(ins)efraim@E5400 ~/workspace/guix-1.2.0$ time ./pre-inst-env guix weather -c 100 --system=aarch64-linux --substitute-urls="https://ci.guix.gnu.org http://pine64:3000"
computing 14,359 package derivations for aarch64-linux...
looking for 14,945 store items on https://ci.guix.gnu.org...
updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
https://ci.guix.gnu.org
  52.4% substitutes available (7,838 out of 14,945)
  at least 25,425.6 MiB of nars (compressed)
  46,859.9 MiB on disk (uncompressed)
  0.002 seconds per request (30.7 seconds in total)
  487.1 requests per second

  0.0% (3 out of 7,107) of the missing items are queued
  at least 1,000 queued builds
      aarch64-linux: 123 (12.3%)
      i686-linux: 401 (40.1%)
      x86_64-linux: 404 (40.4%)
      armhf-linux: 72 (7.2%)
  build rate: 124.61 builds per hour
      x86_64-linux: 50.96 builds per hour
      i686-linux: 35.14 builds per hour
      armhf-linux: 17.95 builds per hour
      aarch64-linux: 20.57 builds per hour
updating substitutes from 'https://ci.guix.gnu.org'... 100.0%
1857 packages are missing from 'https://ci.guix.gnu.org' for 'aarch64-linux', among which:
  1625  [email-masked]     /gnu/store/iaw29nqdhsvpg1zi4xh2i7q9v813kjyw-rust-1.24.1-cargo /gnu/store/kgn4q5nfdmh4hx32b1zd907ri0a26x26-rust-1.24.1-doc /gnu/store/fm
k8vnwc1x8a91w5ybdrfbfrfiq91d3y-rust-1.24.1
   766  [email-masked]      /gnu/store/zcvd3yqka7s1gn323y202rqxirmldawi-ghc-7.10.2-doc /gnu/store/vhhjk5z31rgxw82bv3dmrhz2fyhvh3yl-ghc-7.10.2
   749  [email-masked]    /gnu/store/d06vsnv4rbkz389g7wrh0xbr3mb37rbk-r-yaml-2.2.1
   747  [email-masked]     /gnu/store/gjwsyw35p4c6cd7gqrnl4xjpgys6pic7-r-highr-0.8
   562  [email-masked]     /gnu/store/mwgkpyjgrw4cnvkhglz2605i7c1rpfva-jamvm-1.5.1
   509  [email-masked]       /gnu/store/javclx2bycs1ig5rc0z5zw86ljwc5x5m-sbcl-lift-1.7.1-1.7d49a66
   488  [email-masked]   /gnu/store/l50wdpz16295diabmp2pkkvz2q0f52p3-r-rlang-0.4.8
   487  [email-masked]       /gnu/store/mk4lpkafkbpsncf7qf7i310ix9h14xal-sbcl-net.didierverna.asdf-flv-2.1
   451  [email-masked]   /gnu/store/0n560alajilbryj94z46wabfkq6hjjm9-r-bh-1.72.0-3
   436  [email-masked]       /gnu/store/s4cghmgb9pf79zw9z81lnp9ff5rx6p0g-sbcl-trivial-gray-streams-0.0.0-1.ebd59b1
   245  [email-masked] /gnu/store/2gwfqxkpjvk4yjycs26n17dxkxd2w5m0-r-munsell-0.5.0
   236  [email-masked]        /gnu/store/2g3c41lnvir5rr5ppn3svf2acqzs2290-r-r-cache-0.14.0
   236  [email-masked] /gnu/store/znfcdhp684zvjcipi5dvydn5886xzsa4-sbcl-cffi-libffi-0.21.0
   175  [email-masked]       /gnu/store/6qi0yj1i61py5mhg02vll8b6gbjilngl-libpipeline-1.5.3
   173  [email-masked]      /gnu/store/gv0jw7rsmjq6a6xzzil1xlml2yd59mm8-r-curl-4.3
   169  [email-masked]     /gnu/store/d24l9z1an90d9h2dk5zhliwp5rirh6ic-python2-cffi-1.14.0
   160  [email-masked]  /gnu/store/ncbiv7lrikp7hqj6nykd4hsrjillg5rg-python2-iso8601-0.1.12
   156  [email-masked]        /gnu/store/xdxx4w89lqcdi9yzxrjzd2fwbq58a7dk-python2-pytest-cov-2.8.1
   156  [email-masked] /gnu/store/c4mch43a7w4ivhrcz0wkfb2936dyr8p3-sbcl-closer-mop-1.0.0-2.19c9d33
   154  [email-masked] /gnu/store/2lhmsz7k8hgqhgahcj6bfcgmknnfbk5w-kservice-5.70.0
   151  [email-masked]        /gnu/store/5yfkcacmm4lpygvfb8xk291p9f10c244-r-survival-3.2-7
   148  [email-masked]       /gnu/store/zz75ir2q0k7gd6wprr42vxg7vsjcrb0i-sbcl-trivial-garbage-0.21
   138  [email-masked]       /gnu/store/6apvh159ld0b1rwsbzav1ls90bgiq5ad-cl-trivial-features-0.8-1.870d03d
   132  [email-masked]        /gnu/store/hc6aami5qjwrmdfsj0m6rky5qsz0518n-python2-markupsafe-1.1.1
   128  [email-masked]    /gnu/store/kpwiaj4ng31p71p15rdww6fnggc54l8w-zeromq-4.3.3
   113  [email-masked]        /gnu/store/2hv5x29z673nzn4m11h21xxzgb0k47hv-webkitgtk-2.30.2-doc /gnu/store/whxb77cnsbhwd0dn0dcam8hjpz0z5ffy-webkitgtk-2.30.2
   110  [email-masked]  /gnu/store/dlc90qk7152iqf702hkp5y1axb8fr1dj-numactl-2.0.14
   106  [email-masked]     /gnu/store/g6vjsdslm4m3bp6wbz0j9rwnmp3vr1x8-emacs-shut-up-0.3.2
   105  [email-masked]  /gnu/store/ars7lf4vswnw731pklng4dprwmw41km0-emacs-f-0.20.0

real    2m43.059s
user    2m10.339s
sys     0m3.571s

When I reversed the order of the substitute servers:
(ins)efraim@E5400 ~/workspace/guix-1.2.0$ time ./pre-inst-env guix weather -c 100 --system=aarch64-linux --substitute-urls="http://pine64:3000 https://ci.guix.gnu.org"
computing 14,359 package derivations for aarch64-linux...
looking for 14,945 store items on http://pine64:3000...
updating substitutes from 'http://pine64:3000'... 100.0%
http://pine64:3000
  7.7% substitutes available (1,148 out of 14,945)
  unknown substitute sizes
  5,199.5 MiB on disk (uncompressed)
  0.011 seconds per request (171.8 seconds in total)
  86.0 requests per second
  (continuous integration information unavailable)
updating substitutes from 'http://pine64:3000'... 100.0%
4885 packages are missing from 'http://pine64:3000' for 'aarch64-linux', among which:
  10801 [email-masked]    /gnu/store/r7ncfbpi0q153qybcbhpzqf5rf6wg4pg-python-minimal-3.8.2
  10651 [email-masked]    /gnu/store/an00f8f7cq2hdh5pak9f50ngx4xy0bgq-xtrans-1.4.0
  8954  [email-masked]   /gnu/store/3m5kvv8a5196gk1x3n0qdn5f07g9v4gb-autoconf-wrapper-2.69
  8470  [email-masked]  /gnu/store/rwk9qqb61iyn2bqy4w39j4v9llrqc6xk-datefudge-1.23
  <..snip..>

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted